# Copyright 2016, 2017, Cumulus Networks, Inc.  All rights reserved.

NO_LIC=0
INV_LIC=0
OLD_LIC=0

/usr/sbin/switchd -lic 2>/dev/null >/dev/null
rc=$?
case "$rc" in
1)  NO_LIC=1
    ;;
2|3)
    INV_LIC=1
    ;;
esac

[ -f "/etc/cumulus/.license.txt" ] && [ $rc -ne 0 ] && OLD_LIC=1

# License messages are not applicable for Cumulus VX.
if [ -e /etc/cumulus/switchd.env ]; then
    . /etc/cumulus/switchd.env
fi

if [ "$VX" = "-vx" ]; then
    NO_LIC=0
    INV_LIC=0
fi

if [ $NO_LIC -eq 1 ]; then
    echo >&2
    echo >&2
    echo '*****************************************************************' >&2
    echo 'This installation of Cumulus Linux is not licensed.  The front' >&2
    echo 'panel ports will not operate.  To obtain a license, contact' >&2
    echo 'Cumulus Networks: http://cumulusnetworks.com/' >&2
    echo '*****************************************************************' >&2
    echo >&2
    echo >&2
fi

if [ $INV_LIC -eq 1 ]; then
    echo
    echo
    echo '*****************************************************************'
    echo 'The Cumulus Linux license appears to be invalid.'
    echo 'This WILL NOT affect your system operations at the moment.'
    echo 'Future versions will enforce fully valid licenses on the system.'
    echo 'Please contact <licensing@cumulusnetworks.com> at your convenience'
    echo 'so we can validate and assist you with this licensing issue.'
    echo '*****************************************************************'
    echo
    echo
fi


# Disable until old license deprecation
# if [ $OLD_LIC -eq 1 ]; then
#    if [ $INV_LIC -ne 1 ]; then
#        echo >&2
#        echo >&2
#    fi
#    echo '*****************************************************************' >&2
#    echo ' License '/etc/cumulus/.license.txt' contains old format. It will ' >&2
#    echo ' be deprecated in the future. To get a license with new format,' >&2
#    echo ' contact Cumulus Networks <licensing@cumulusnetworks.com>' >&2
#    echo '*****************************************************************' >&2
#    echo >&2
#    echo >&2
#fi
