#
# Copyright (c) 2019.  Cumulus Networks, Inc.  All rights reserved.
#

import os
import subprocess
import cumulus.cpld
import cumulus.sensors

class CelSea2Que2CPLD(cumulus.cpld.SysFS):
    path = '/sys/devices/platform/cel_sea2que2_base_board_cpld.0'

vhwmon_path = '/sys/class/misc/vhwmon'

# Trident3 Sensors

class CelSea2Que2ASICTemp(cumulus.sensors.Temp_Unit):
    driver_path = '/cumulus/switchd/run'
    description = cumulus.sensors.Temp_Unit.mac_die_sensor_name

class CelSea2Que2ASICTemp1(CelSea2Que2ASICTemp):
    name = 'Temp1'
    driver_hwmon = ['temp1']

class CelSea2Que2ASICTemp2(CelSea2Que2ASICTemp):
    name = 'Temp2'
    driver_hwmon = ['temp2']

class CelSea2Que2ASICTemp3(CelSea2Que2ASICTemp):
    name = 'Temp3'
    driver_hwmon = ['temp3']

class CelSea2Que2ASICTemp4(CelSea2Que2ASICTemp):
    name = 'Temp4'
    driver_hwmon = ['temp4']

class CelSea2Que2ASICTemp5(CelSea2Que2ASICTemp):
    name = 'Temp5'
    driver_hwmon = ['temp5']

class CelSea2Que2ASICTemp6(CelSea2Que2ASICTemp):
    name = 'Temp6'
    driver_hwmon = ['temp6']

class CelSea2Que2ASICTemp7(CelSea2Que2ASICTemp):
    name = 'Temp7'
    driver_hwmon = ['temp7']

class CelSea2Que2ASICTemp8(CelSea2Que2ASICTemp):
    name = 'Temp8'
    driver_hwmon = ['temp8']

class CelSea2Que2ASICTemp9(CelSea2Que2ASICTemp):
    name = 'Temp9'
    driver_hwmon = ['temp9']

class CelSea2Que2ASICTemp10(CelSea2Que2ASICTemp):
    name = 'Temp10'
    driver_hwmon = ['temp10']

class CelSea2Que2ASICTemp11(CelSea2Que2ASICTemp):
    name = 'Temp11'
    driver_hwmon = ['temp11']

class CelSea2Que2ASICTemp12(CelSea2Que2ASICTemp):
    name = 'Temp12'
    driver_hwmon = ['temp12']

# BMC Sensors

class CelSea2Que2BMCTemp(cumulus.sensors.Temp_Unit):
    driver_path = vhwmon_path + '/bmc:temp'

class CelSea2Que2BMCTemp1(CelSea2Que2BMCTemp):
    name = 'Temp13'
    description = 'Base_Temp_U5'
    driver_hwmon = ['temp1']

class CelSea2Que2BMCTemp2(CelSea2Que2BMCTemp):
    name = 'Temp14'
    description = 'Base_Temp_U7'
    driver_hwmon = ['temp2']

class CelSea2Que2BMCTemp3(CelSea2Que2BMCTemp):
    name = 'Temp15'
    description = 'CPU_Temp'
    driver_hwmon = ['temp3']

class CelSea2Que2BMCTemp4(CelSea2Que2BMCTemp):
    name = 'Temp16'
    description = 'Switch_Temp_U1'
    driver_hwmon = ['temp4']

class CelSea2Que2BMCTemp5(CelSea2Que2BMCTemp):
    name = 'Temp17'
    description = 'Switch_Temp_U18'
    driver_hwmon = ['temp5']

class CelSea2Que2BMCTemp6(CelSea2Que2BMCTemp):
    name = 'Temp18'
    description = 'Switch_Temp_U28'
    driver_hwmon = ['temp6']

class CelSea2Que2BMCTemp7(CelSea2Que2BMCTemp):
    name = 'Temp19'
    description = 'Switch_Temp_U29'
    driver_hwmon = ['temp7']

class CelSea2Que2BMCTemp8(CelSea2Que2BMCTemp):
    name = 'Temp20'
    description = 'Switch_U33_Temp'
    driver_hwmon = ['temp8']

class CelSea2Que2BMCTemp9(CelSea2Que2BMCTemp):
    name = 'Temp21'
    description = 'Switch_U21_Temp'
    driver_hwmon = ['temp9']

# BMC Fans

class CelSea2Que2Fan(cumulus.sensors.Fan_Unit):
    driver_path = vhwmon_path + '/bmc:fan'
    no_pwm = True

class CelSea2Que2Fan1(CelSea2Que2Fan):
    name = 'Fan1'
    description = 'Fan1_Rear'
    driver_hwmon = ['fan5']

class CelSea2Que2Fan2(CelSea2Que2Fan):
    name = 'Fan2'
    description = 'Fan1_Front'
    driver_hwmon = ['fan6']

class CelSea2Que2Fan3(CelSea2Que2Fan):
    name = 'Fan3'
    description = 'Fan2_Rear'
    driver_hwmon = ['fan7']

class CelSea2Que2Fan4(CelSea2Que2Fan):
    name = 'Fan4'
    description = 'Fan2_Front'
    driver_hwmon = ['fan8']

class CelSea2Que2Fan5(CelSea2Que2Fan):
    name = 'Fan5'
    description = 'Fan3_Rear'
    driver_hwmon = ['fan9']

class CelSea2Que2Fan6(CelSea2Que2Fan):
    name = 'Fan6'
    description = 'Fan3_Front'
    driver_hwmon = ['fan10']

class CelSea2Que2Fan7(CelSea2Que2Fan):
    name = 'Fan7'
    description = 'Fan4_Rear'
    driver_hwmon = ['fan11']

class CelSea2Que2Fan8(CelSea2Que2Fan):
    name = 'Fan8'
    description = 'Fan4_Front'
    driver_hwmon = ['fan12']

# BMC PSUs

class CelSea2Que2PSU(cumulus.sensors.PSU_Unit):
    cpld_path = CelSea2Que2CPLD.path

class CelSea2Que2PSU1(CelSea2Que2PSU):
    name = 'PSU1'
    description = 'PSU1'
    cpld_hwmon = ['psu_pwr1']

class CelSea2Que2PSU2(CelSea2Que2PSU):
    name = 'PSU2'
    description = 'PSU2'
    cpld_hwmon = ['psu_pwr2']

class CelSea2Que2PSUFan(cumulus.sensors.Fan_Unit):
    driver_hwmon = ['fan1']
    no_pwm = True

class CelSea2Que2PSU1Fan1(CelSea2Que2PSUFan):
    driver_path = vhwmon_path + '/bmc:psul'
    name = 'PSU1Fan1'
    description = 'PSU1 Fan1'
    psu = 'PSU1'

class CelSea2Que2PSU2Fan1(CelSea2Que2PSUFan):
    driver_path = vhwmon_path + '/bmc:psur'
    name = 'PSU2Fan1'
    description = 'PSU2 Fan1'
    psu = 'PSU2'

class CelSea2Que2PSUTemp(cumulus.sensors.Temp_Unit):
    def find_and_add_attrs(self):
        state = 'OK'
        try:
            path = os.path.join(self.status_path, self.psu, 'state')
            with open(path) as fp:
                state = fp.read().rsplit('\n')[0]
        except:
            return -1
        if (state != 'OK'):
            return -1
        return cumulus.sensors.Temp_Unit.find_and_add_attrs(self)

class CelSea2Que2PSU1Temp1(CelSea2Que2PSUTemp):
    driver_path = vhwmon_path + '/bmc:psul'
    driver_hwmon = ['temp1']
    name = 'PSU1Temp1'
    description = 'PSU1 Temp1'
    psu = 'PSU1'

class CelSea2Que2PSU2Temp1(CelSea2Que2PSUTemp):
    driver_path = vhwmon_path + '/bmc:psur'
    driver_hwmon = ['temp1']
    name = 'PSU2Temp1'
    description = 'PSU2 Temp1'
    psu = 'PSU2'

class CelSea2Que2PSU1Temp2(CelSea2Que2PSUTemp):
    driver_path = vhwmon_path + '/bmc:psul'
    driver_hwmon = ['temp2']
    name = 'PSU1Temp2'
    description = 'PSU1 Temp2'
    psu = 'PSU1'

class CelSea2Que2PSU2Temp2(CelSea2Que2PSUTemp):
    driver_path = vhwmon_path + '/bmc:psur'
    driver_hwmon = ['temp2']
    name = 'PSU2Temp2'
    description = 'PSU2 Temp2'
    psu = 'PSU2'

class CelSea2Que2BMC(cumulus.platform.BMC):
    name = 'bmc'
    type = 'ipmibmc'

