#
# Copyright 2017.  Cumulus Networks, Inc.
#

import cumulus.platform
import cumulus.cpld
import cumulus.ledup
import cumulus.sunit
import cumulus.sfp
import cumulus.sensors
import cumulus.platforms.mlnx_msn2740
import cumulus.platforms.mlnx_x86_MSN2700B

class MlxSN2740B(cumulus.platform.Platform):
    name = 'mlnx,msn2740b'
    chip = cumulus.platform.SpectrumChip()
    switch = cumulus.platforms.mlnx_x86_MSN2700B.MlxSN2700BSwitch(chip)
    cpld = cumulus.platforms.mlnx_msn2740.MlxSN2740CPLD()
    sensors = cumulus.platforms.mlnx_msn2740.MlxSN2740Sensors()
    pwms = cumulus.platforms.mlnx_msn2740.MlxSN2740PWMs()
    statusleds = cumulus.platforms.mlnx_msn2740.MlxSN2740LEDs()

Platform = MlxSN2740B
